create or replace package RT_GRAPH is

  -- Author  : POMATTI
  -- Created : 20/05/2007 22.32.12
  -- Purpose : 
  
  -- Public type declarations
  type ref_cursor is ref cursor;
  
  -- Public constant declarations

  -- Public variable declarations

  -- Public function and procedure declarations
  function "ELAB_CUMULATED" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor;
  function "ELAB_CUMULATED_6H" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor;
  function "ELAB_CUMULATED_12H" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor;
  function "ELAB_CUMULATED_24H" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor;
  function "ELAB_CUMULATED_48H" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor;
  function "ELAB_DAILY_MAX" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor;
  function "ELAB_DAILY_MID" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor;
  function "ELAB_DAILY_MIN" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor;
  function "ELAB_DAILYTOT" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor;
  function "ELAB_HOURLY_MID" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor;
  function "ELAB_TEMPORAL_TREND" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor;
  function "ELAB_TYPICALDAY" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor;
  function "ELAB_TYPICALDAYBYCLAS" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor;
end RT_GRAPH;

 
/
create or replace package body RT_GRAPH is

  -- Private type declarations
  
  -- Private constant declarations

  -- Private variable declarations

  -- Function and procedure implementations
  
/*  procedure LOG(log_value in varchar2) as
    id         number;
    shortvalue varchar2(4000);
  begin
    select nvl(max(l.id) + 1, 1) into id from log l;
    --dbms_output.put_line(   LENGTH(log_value) );
    shortvalue := SUBSTR(log_value, 1, 4000);
    insert into log values (id, shortvalue, sysdate);
    if (LENGTH(log_value) > 4000) then
      shortvalue := SUBSTR(log_value, 4001, 8000);
      insert into log values (id + 1, shortvalue, sysdate);
    end if;
    commit;
  end;
*/  
  function "ELAB_CUMULATED" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor
  as
    result ref_cursor;
    
  begin
    if sensorId = 301 then
      open result for 'select	a.DATA_RILEVAMENTO, nvl(sum(hpm.cumulata_r(a.NUMERO_DAS, :dateFrom, a.DATA_RILEVAMENTO)),0) cumval, round(sum(decode(a.STATO,1,1,0))/count(decode(a.STATO,1,1,0))*100,2) percvalid ' ||
        'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b ' ||
        'where a.NUMERO_DAS = b.NUMERO_DAS and b.' || geoField || ' = :geoId and a.DATA_RILEVAMENTO between :dateFrom and :dateTo ' ||
        'group by a.DATA_RILEVAMENTO ' ||
        'order by a.DATA_RILEVAMENTO' using dateFrom, sensorId, geoId, dateFrom, dateTo;
  
      return result;
    end if;
  
    open result for 'select * from dual where 0 = 1';
    return result;
  end;

  function "ELAB_CUMULATED_6H" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor
  as
    result ref_cursor;
    
  begin
    if sensorId = 301 then
      open result for 'select dataril, value, percvalid ' ||
    	   'from (select a.DATA_RILEVAMENTO dataril, nvl(sum(hpm.cumulata_r(a.NUMERO_DAS, c.DATAF_RT-6/24, a.DATA_RILEVAMENTO)),0) value, round(sum(decode(a.STATO,1,1,0))/count(decode(a.STATO,1,1,0))*100,2) percvalid ' ||
    	   'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b, monitoraggio.SINTESI_MISURE c ' ||
    	   'where	a.NUMERO_DAS = b.NUMERO_DAS and a.NUMERO_DAS = c.NUMERO_DAS and b.' || geoField || ' = :geoId and a.DATA_RILEVAMENTO between c.DATAF_RT-6/24 and c.DATAF_RT+1/24 ' ||
    	   'group by a.DATA_RILEVAMENTO) ' ||
    	   'order by dataril' using sensorId, geoId;
  
      return result;
    end if;
  
    open result for 'select * from dual where 0 = 1';
    return result;
  end;

  function "ELAB_CUMULATED_12H" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor
  as
    result ref_cursor;
    
  begin
    if sensorId = 301 then
      open result for 'select dataril, value, percvalid ' ||
    	   'from (select a.DATA_RILEVAMENTO dataril, nvl(sum(hpm.cumulata_r(a.NUMERO_DAS, c.DATAF_RT-12/24, a.DATA_RILEVAMENTO)),0) value, round(sum(decode(a.STATO,1,1,0))/count(decode(a.STATO,1,1,0))*100,2) percvalid ' ||
    	   'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b, monitoraggio.SINTESI_MISURE c ' ||
    	   'where	a.NUMERO_DAS = b.NUMERO_DAS and a.NUMERO_DAS = c.NUMERO_DAS and b.' || geoField || ' = :geoId and a.DATA_RILEVAMENTO between c.DATAF_RT-12/24 and c.DATAF_RT+1/24 ' ||
    	   'group by a.DATA_RILEVAMENTO) ' ||
    	   'order by dataril' using sensorId, geoId;
  
      return result;
    end if;
  
    open result for 'select * from dual where 0 = 1';
    return result;
  end;

  function "ELAB_CUMULATED_24H" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor
  as
    result ref_cursor;
    
  begin
    if sensorId = 301 then
      open result for 'select dataril, value, percvalid ' ||
    	   'from (select a.DATA_RILEVAMENTO dataril, nvl(sum(hpm.cumulata_r(a.NUMERO_DAS, c.DATAF_RT-24/24, a.DATA_RILEVAMENTO)),0) value, round(sum(decode(a.STATO,1,1,0))/count(decode(a.STATO,1,1,0))*100,2) percvalid ' ||
    	   'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b, monitoraggio.SINTESI_MISURE c ' ||
    	   'where	a.NUMERO_DAS = b.NUMERO_DAS and a.NUMERO_DAS = c.NUMERO_DAS and b.' || geoField || ' = :geoId and a.DATA_RILEVAMENTO between c.DATAF_RT-24/24 and c.DATAF_RT+1/24 ' ||
    	   'group by a.DATA_RILEVAMENTO) ' ||
    	   'order by dataril' using sensorId, geoId;
  
      return result;
    end if;
  
    open result for 'select * from dual where 0 = 1';
    return result;
  end;

  function "ELAB_CUMULATED_48H" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor
  as
    result ref_cursor;
    
  begin
    if sensorId = 301 then
      open result for 'select dataril, value, percvalid ' ||
    	   'from (select a.DATA_RILEVAMENTO dataril, nvl(sum(hpm.cumulata_r(a.NUMERO_DAS, c.DATAF_RT-48/24, a.DATA_RILEVAMENTO)),0) value, round(sum(decode(a.STATO,1,1,0))/count(decode(a.STATO,1,1,0))*100,2) percvalid ' ||
  	     'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b, monitoraggio.SINTESI_MISURE c ' ||
  	     'where	a.NUMERO_DAS = b.NUMERO_DAS and a.NUMERO_DAS = c.NUMERO_DAS and b.' || geoField || ' = :geoId and a.DATA_RILEVAMENTO between c.DATAF_RT-48/24 and c.DATAF_RT+1/24 ' ||
    	   'group by a.DATA_RILEVAMENTO) ' ||
  	     'order by dataril' using sensorId, geoId;
  
      return result;
    end if;
  
    open result for 'select * from dual where 0 = 1';
    return result;
  end;

  function "ELAB_DAILY_MAX" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor
  as
    result ref_cursor;
    
  begin
    if sensorId = 301 then
       open result for 'select dataril, maxval, percvalid ' ||
          'from (select	to_date(to_char(a.DATA_RILEVAMENTO, ''dd-mm-yyyy''), ''dd-mm-yyyy'') dataril, round(nvl(max(decode(sign(a.VALORE - hpm.valprec_r(A.NUMERO_DAS, A.DATA_RILEVAMENTO)), -1, decode(sign((hpm.valprec_r(a.NUMERO_DAS, a.DATA_RILEVAMENTO) - a.VALORE) - 0.5), -1, 0, 0, 0, a.VALORE), a.VALORE - hpm.valprec_r(A.NUMERO_DAS, A.DATA_RILEVAMENTO))),0),2) maxval, round(sum(decode(a.STATO,1,1,0))/count(decode(a.STATO,1,1,0))*100,2) percvalid '||
          'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b ' ||
          'where a.NUMERO_DAS = b.NUMERO_DAS and b.' || geoField || ' = :geoid and a.DATA_RILEVAMENTO between :dateFrom and :dateTo ' ||
          'group by to_date(to_char(a.DATA_RILEVAMENTO, ''dd-mm-yyyy''), ''dd-mm-yyyy'')) ' ||
          'order by to_date( dataril, ''yyyy-mm-dd'')' using sensorId, geoId, dateFrom, dateTo;
  
       return result;
    end if;
  
      open result for 'select dataril, maxval, percvalid ' ||
           'from (select to_date(to_char(a.DATA_RILEVAMENTO, ''dd-mm-yyyy''), ''dd-mm-yyyy'') dataril, round(nvl(max(a.VALORE),0),2) maxval, round(sum(decode(a.STATO,1,1,0))/count(decode(a.STATO,1,1,0))*100,2) percvalid ' ||
           'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b ' ||
           'where a.NUMERO_DAS = b.NUMERO_DAS and b.' || geoField || ' = :geoId and a.DATA_RILEVAMENTO between :dateFrom and :dateTo ' ||
           'group by to_date(to_char(a.DATA_RILEVAMENTO, ''dd-mm-yyyy''), ''dd-mm-yyyy'')) ' ||
           'order by dataril' using sensorId, geoId, dateFrom, dateTo;
  
      return result;
  end;

  function "ELAB_DAILY_MID" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor
  as
    result ref_cursor;
    
  begin
    if sensorId = 301 then
       open result for 'select dataril, mediaval, percvalid ' ||
          'from (select to_date(to_char(a.DATA_RILEVAMENTO, ''dd-mm-yyyy''), ''dd-mm-yyyy'') dataril, round(nvl(avg(decode(sign(a.VALORE - hpm.valprec_r(A.NUMERO_DAS, A.DATA_RILEVAMENTO)), -1, decode(sign((hpm.valprec_r(a.NUMERO_DAS, a.DATA_RILEVAMENTO) - a.VALORE) - 0.5), -1, 0, 0, 0, a.VALORE), a.VALORE - hpm.valprec_r(A.NUMERO_DAS, A.DATA_RILEVAMENTO))),0),2) mediaval, round(sum(decode(a.STATO,1,1,0))/count(decode(a.STATO,1,1,0))*100,2) percvalid '||
          'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b ' ||
          'where a.NUMERO_DAS = b.NUMERO_DAS and b.' || geoField || ' = :geoid and a.DATA_RILEVAMENTO between :dateFrom and :dateTo ' ||
          'group by to_date(to_char(a.DATA_RILEVAMENTO, ''dd-mm-yyyy''), ''dd-mm-yyyy'')) ' ||
          'order by dataril' using sensorId, geoId, dateFrom, dateTo;
  
       return result;
    end if;
  
    open result for 'select	dataril, mediaval, percvalid ' ||
         'from (select to_date(to_char(a.DATA_RILEVAMENTO, ''dd-mm-yyyy''), ''dd-mm-yyyy'') dataril, round(nvl(avg(a.VALORE),0),2) mediaval, round(sum(decode(a.STATO,1,1,0))/count(decode(a.STATO,1,1,0))*100,2) percvalid ' ||
         'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b ' ||
         'where a.NUMERO_DAS = b.NUMERO_DAS and b.' || geoField || ' = :geoId and a.DATA_RILEVAMENTO between :dateFrom and :dateTo ' ||
         'group by to_date(to_char(a.DATA_RILEVAMENTO, ''dd-mm-yyyy''), ''dd-mm-yyyy'')) ' ||
         'order by dataril' using sensorId, geoId, dateFrom, dateTo;
  
      return result;
  end;

  function "ELAB_DAILY_MIN" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor
  as
    result ref_cursor;
    
  begin
    if sensorId = 301 then
       open result for 'select dataril, minval, percvalid ' ||
          'from (select to_date(to_char(a.DATA_RILEVAMENTO, ''dd-mm-yyyy''), ''dd-mm-yyyy'') dataril, round(nvl(min(decode(sign(a.VALORE - hpm.valprec_r(A.NUMERO_DAS, A.DATA_RILEVAMENTO)), -1, decode(sign((hpm.valprec_r(a.NUMERO_DAS, a.DATA_RILEVAMENTO) - a.VALORE) - 0.5), -1, 0, 0, 0, a.VALORE), a.VALORE - hpm.valprec_r(A.NUMERO_DAS, A.DATA_RILEVAMENTO))),0),2) minval, round(sum(decode(a.STATO,1,1,0))/count(decode(a.STATO,1,1,0))*100,2) percvalid '||
          'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b ' ||
          'where a.NUMERO_DAS = b.NUMERO_DAS and b.' || geoField || ' = :geoid and a.DATA_RILEVAMENTO between :dateFrom and :dateTo ' ||
          'group by to_date(to_char(a.DATA_RILEVAMENTO, ''dd-mm-yyyy''), ''dd-mm-yyyy'')) ' ||
          'order by dataril ' using sensorId, geoId, dateFrom, dateTo;
  
       return result;
    end if;
  
    open result for 'select dataril, minval, percvalid ' ||
         'from (select to_date(to_char(a.DATA_RILEVAMENTO, ''dd-mm-yyyy''), ''dd-mm-yyyy'') dataril, round(nvl(min(a.VALORE),0),2) minval, round(sum(decode(a.STATO,1,1,0))/count(decode(a.STATO,1,1,0))*100,2) percvalid ' ||
         'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b ' ||
         'where a.NUMERO_DAS = b.NUMERO_DAS and b.' || geoField || ' = :geoId and a.DATA_RILEVAMENTO between :dateFrom and :dateTo ' ||
         'group by to_date(to_char(a.DATA_RILEVAMENTO, ''dd-mm-yyyy''), ''dd-mm-yyyy'')) ' ||
         'order by dataril' using sensorId, geoId, dateFrom, dateTo;
  
      return result;
  end;

  function "ELAB_DAILYTOT" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor
  as
    result ref_cursor;
    
  begin
    if sensorId = 301 then
       open result for 'select dataril, cumval, percvalidi '||
          'from (	select to_date(to_char(a.DATA_RILEVAMENTO, ''dd-mm-yyyy''), ''dd-mm-yyyy'') dataril, round(nvl(avg(hpm.cumulata_r(a.NUMERO_DAS, hpm.datapiu9ore(a.DATA_RILEVAMENTO), hpm.datapiu9ore(a.DATA_RILEVAMENTO+1))),0),2) cumval, round(sum(decode(a.STATO,1,1,0))/count(decode(a.STATO,1,1,0))*100,2) percvalidi '||
  	      'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b '||
  	      'where	a.NUMERO_DAS=b.NUMERO_DAS AND b.' || geoField || ' = :geoid AND a.DATA_RILEVAMENTO between :dateFrom AND :dateTo AND to_char(a.DATA_RILEVAMENTO,''HH24'') in (''00'') AND to_char(a.DATA_RILEVAMENTO,''mi'') in (''00'') '||
  	      'group by to_date(to_char(a.DATA_RILEVAMENTO, ''dd-mm-yyyy''), ''dd-mm-yyyy'')) '||
  	      'order by dataril' using sensorId, geoId, dateFrom, dateTo;
  
       return result;
    end if;
  
    open result for 'select * from dual where 0 = 1';
    return result;
  end;

  function "ELAB_HOURLY_MID" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor
  as
    result ref_cursor;
    
  begin
    if sensorId = 301 then
    open result for 'select	to_date(to_char(a.DATA_RILEVAMENTO, ''hh24 dd-mm-yyyy''), ''hh24 dd-mm-yyyy''), round(nvl(avg(decode(sign(a.VALORE - hpm.valprec_r(a.NUMERO_DAS, a.DATA_RILEVAMENTO)), -1, decode(sign((hpm.valprec_r(a.NUMERO_DAS, a.DATA_RILEVAMENTO) - a.VALORE) - 0.5), -1, 0, 0, 0, a.VALORE), a.VALORE - hpm.valprec_r(a.NUMERO_DAS, a.DATA_RILEVAMENTO))),0),2), round(sum(decode(a.STATO,1,1,0))/count(decode(a.STATO,1,1,0))*100,2) '||
          'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b '||
          'where a.NUMERO_DAS = b.NUMERO_DAS and b.' || geoField || ' = :geoid and a.DATA_RILEVAMENTO between :dateFrom and :dateTo '||
          'group by to_date(to_char(a.DATA_RILEVAMENTO, ''hh24 dd-mm-yyyy''), ''hh24 dd-mm-yyyy'') ' ||
          'order by to_date(to_char(a.DATA_RILEVAMENTO, ''hh24 dd-mm-yyyy''), ''hh24 dd-mm-yyyy'')' using sensorId, geoId, dateFrom, dateTo;
  
       return result;
    end if;
  
    open result for 'select to_date(to_char(a.DATA_RILEVAMENTO, ''hh24 dd-mm-yyyy''), ''hh24 dd-mm-yyyy''), round(nvl(avg(a.VALORE),0),2), round(sum(decode(a.STATO,1,1,0))/count(decode(a.STATO,1,1,0))*100,2) ' ||
    	 'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b ' ||
  	   'where a.NUMERO_DAS = b.NUMERO_DAS and b.' || geoField || ' = :geoId and a.DATA_RILEVAMENTO between	:dateFrom and :dateTo ' ||
  	   'group by to_date(to_char(a.DATA_RILEVAMENTO, ''hh24 dd-mm-yyyy''), ''hh24 dd-mm-yyyy'') ' ||
  	   'order by to_date(to_char(a.DATA_RILEVAMENTO, ''hh24 dd-mm-yyyy''), ''hh24 dd-mm-yyyy'')' using sensorId, geoId, dateFrom, dateTo;
  
      return result;
  end;

  function ELAB_TEMPORAL_TREND (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor
  as
    result ref_cursor;
    
  begin
    --log_txt('ELAB_TEMPORAL_TREND (sensorId=' || sensorId || ', geoField=' || geoField ||
    --        ', geoId=' || geoId || ', dateFrom=' || dateFrom || ', dateTo=' || dateTo || ')');
    if sensorId = 301 then
      open result for 'select a.DATA_RILEVAMENTO, round(nvl(avg(decode(sign(a.VALORE - hpm.valprec_r(a.NUMERO_DAS, a.DATA_RILEVAMENTO)), -1, decode(sign((hpm.valprec_r(a.NUMERO_DAS, a.DATA_RILEVAMENTO) - a.VALORE) - 0.5), -1, 0, 0, 0, a.VALORE), a.VALORE - hpm.valprec_r(a.NUMERO_DAS, a.DATA_RILEVAMENTO))),0),2), round(sum(decode(a.STATO,1,1,0))/count(decode(a.STATO,1,1,0))*100,2) ' ||
          'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b ' ||
          'where a.NUMERO_DAS = b.NUMERO_DAS and b.' || geoField || ' = :geoId and a.DATA_RILEVAMENTO between	:dateFrom and :dateTo ' ||
          'group by a.DATA_RILEVAMENTO ' ||
          'order by a.DATA_RILEVAMENTO' using sensorId, geoId, dateFrom, dateTo;
  
      return result;
    end if;

    if sensorId = 802 and geoField = 'COD_STAZIONE' then
      open result for 'select a.DATA_RILEVAMENTO, round(nvl(avg(a.VALORE), 0), 2), ' ||
         'nvl(hpm.get_portata(:geoId, avg(a.VALORE)), 0), ' ||
         'round(sum(decode(a.STATO, 1, 1, 0)) / count(decode(a.STATO, 1, 1, 0)) * 100, 2) ' ||
      	 'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b ' ||
    	   'where a.NUMERO_DAS = b.NUMERO_DAS and b.COD_STAZIONE = :geoId and a.DATA_RILEVAMENTO between :dateFrom and :dateTo ' ||
    	   'group by a.DATA_RILEVAMENTO ' ||
    	   'order by a.DATA_RILEVAMENTO' using geoId, sensorId, geoId, dateFrom, dateTo;
      return result;
      /*
      open result for 'select a.DATA_RILEVAMENTO, round(nvl(avg(a.VALORE),0),2), ' || 
         'nvl(hpm.get_portata(:geoId,avg(a.VALORE)),0), ' ||
         'round(sum(decode(a.STATO,1,1,0))/count(decode(a.STATO,1,1,0))*100,2) ' ||
      	 'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b ' ||
    	   'where a.NUMERO_DAS = b.NUMERO_DAS and b.' || geoField || ' = :geoId and a.DATA_RILEVAMENTO between	:dateFrom and :dateTo ' ||
    	   'group by a.DATA_RILEVAMENTO ' ||
    	   'order by a.DATA_RILEVAMENTO' using sensorId, geoId, dateFrom, dateTo;
      return result;
      */
    end if;
  
    open result for 'select a.DATA_RILEVAMENTO, round(nvl(avg(a.VALORE),0),2), round(sum(decode(a.STATO,1,1,0))/count(decode(a.STATO,1,1,0))*100,2) ' ||
    	 'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b ' ||
  	   'where a.NUMERO_DAS = b.NUMERO_DAS and b.' || geoField || ' = :geoId and a.DATA_RILEVAMENTO between	:dateFrom and :dateTo ' ||
  	   'group by a.DATA_RILEVAMENTO ' ||
  	   'order by a.DATA_RILEVAMENTO' using sensorId, geoId, dateFrom, dateTo;
  
    return result;
  end;

  function "ELAB_TYPICALDAY" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor
  as
    result ref_cursor;
  
  begin
    if sensorId = 301 then
    open result for 'select	to_date(to_char(a.DATA_RILEVAMENTO,''hh24''), ''hh24''), nvl(avg(hpm.cumulata_r(a.NUMERO_DAS,a.DATA_RILEVAMENTO-1/24,a.DATA_RILEVAMENTO)),0) ' ||
          'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b ' ||
          'where a.NUMERO_DAS = b.NUMERO_DAS and b.' || geoField || ' = :geoid and a.DATA_RILEVAMENTO between	:dateFrom and :dateTo ' ||
          'group by to_date(to_char(a.DATA_RILEVAMENTO,''hh24''), ''hh24'') ' ||
          'order by to_date(to_char(a.DATA_RILEVAMENTO,''hh24''), ''hh24'')' using sensorId, geoId, dateFrom, dateTo;
  
       return result;
    end if;
  
    open result for 'select	to_date(to_char(a.DATA_RILEVAMENTO,''hh24''), ''hh24''), nvl(avg(a.VALORE),0) ' ||
          'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b ' ||
          'where a.NUMERO_DAS = b.NUMERO_DAS and b.' || geoField || ' = :geoid and a.DATA_RILEVAMENTO between	:dateFrom and :dateTo ' ||
          'group by to_date(to_char(a.DATA_RILEVAMENTO,''hh24''), ''hh24'') ' ||
          'order by to_date(to_char(a.DATA_RILEVAMENTO,''hh24''), ''hh24'')' using sensorId, geoId, dateFrom, dateTo;
  
      return result;
  end;

  function "ELAB_TYPICALDAYBYCLAS" (sensorId in number, geoField in string, geoId in string, dateFrom in date, dateTo in date) return ref_cursor
  as
    result ref_cursor;
    
  begin
    if sensorId = 112 then
      open result for 'select	to_date(to_char(a.DATA_RILEVAMENTO,''hh24''), ''hh24''), ' ||
            'sum(nvl(decode(floor((a.VALORE+22.5)/45),0,1,8,1,0),0)), ' ||
    	      'sum(nvl(decode(floor((a.VALORE+22.5)/45),1,1,0),0)), ' ||
    	      'sum(nvl(decode(floor((a.VALORE+22.5)/45),2,1,0),0)), ' ||
           	'sum(nvl(decode(floor((a.VALORE+22.5)/45),3,1,0),0)), ' ||
          	'sum(nvl(decode(floor((a.VALORE+22.5)/45),4,1,0),0)), ' ||
          	'sum(nvl(decode(floor((a.VALORE+22.5)/45),5,1,0),0)), ' ||
    	      'sum(nvl(decode(floor((a.VALORE+22.5)/45),6,1,0),0)), ' ||
          	'sum(nvl(decode(floor((a.VALORE+22.5)/45),7,1,0),0)), ' ||
  	        'sum(nvl(decode(a.VALORE,7777,1,0),0)), ' ||
          	'sum(nvl(decode(a.VALORE,8888,1,0),0)), ' ||
           	'sum(nvl(decode(floor((a.VALORE+22.5)/45),0,0,1,0,2,0,3,0,4,0,5,0,6,0,7,0,8,0,1),0)) ' ||
            'from monitoraggio.MISURE a, (select * from monitoraggio.SINTESI_RETE where COD_SENSORE = :sensorId) b ' ||
            'where a.NUMERO_DAS = b.NUMERO_DAS and b.' || geoField || ' = :geoid and a.DATA_RILEVAMENTO between	:dateFrom and :dateTo ' ||
            'group by to_date(to_char(a.DATA_RILEVAMENTO,''hh24''), ''hh24'') ' ||
            'order by to_date(to_char(a.DATA_RILEVAMENTO,''hh24''), ''hh24'')' using sensorId, geoId, dateFrom, dateTo;
  
      return result;
    end if;
  
    open result for 'select * from dual where 0 = 1';
    return result;
  end;
end RT_GRAPH;
/
